;Source code for Alien Blitz version 1.00 by Shane Kennedy
;This will not compile without the original media files.
;Please contact me if you wish to obtain the media. 
;dpw-shane@blueyonder.co.uk

AppTitle "Dam Breach by Shane Kennedy","Exit Dam Breach?"

;constants
Const ScrWidth = 640
Const ScrHeight = 480


;variables
Dim DamArray(4,ScrHeight/10)
Global ContinueGame = True
Global startgame = False
Global missilerange = ScrHeight/2
Global score
Global bestscore


;graphics
Global MenuBackground
Global GameBackground
Global gun_top
Global gun_bottom
Global ufo
Global missile_up
Global missile_down
Global dam


;sounds
Global ufo_sound
Global missile_sound
Global explosion_sound


;environment
Graphics ScrWidth,ScrHeight,0,2
SeedRnd MilliSecs() 


;mainloop
LoadAll()
While ContinueGame

	Menu()
	If startgame Then
		Initialise()
		PlayGame()
	Else
		ContinueGame = False
	End If
	
Wend
ExitGame()


Function LoadAll()
	
	MenuBackground = LoadImage("Media\MenuBackground.jpg")

	ufo = LoadImage("Media\ufo.bmp")
	MaskImage ufo,255,255,255
	
	GameBackground = LoadImage("Media\GameBackground.jpg")

	missile_down = LoadImage("Media\missiledown.bmp")
	missile_up = LoadImage("Media\missileup.bmp")
	
	gun_bottom = LoadImage("Media\gun_bottom.bmp")
	gun_top = LoadImage("Media\gun_top.bmp")
	MaskImage gun_bottom,255,0,255
	MaskImage gun_top,255,0,255
	
	dam = LoadImage("Media\dam.bmp")
	
	ufo_sound = LoadSound("Media\ufo.wav")
	missile_sound = LoadSound("Media\missile.wav")
	explosion_sound = LoadSound("Media\explosion.wav")
	SoundVolume missile_sound,0.8
	SoundVolume explosion_sound,0.5
	
	;load all player data
	If FileType("DamBreach.dat")=1 Then
		UserDataFile = ReadFile("DamBreach.dat")
		bestscore = ReadShort(UserDataFile)
		CloseFile(UserDataFile)
	Else
		bestscore = 0
	End If
	
	SetBuffer BackBuffer()

End Function

Function Initialise()
	
	For i = 1 To 4
		For j = 6 To ScrHeight/10 - 7
			DamArray(i,j) = 1
		Next
	Next 
	
End Function

Function Menu()

	score = 0
	
	Repeat 
	
		DrawBlock MenuBackground,0,0
		
		If KeyHit(57) Then
			startgame = True
			Exit
		End If
		
		If KeyHit(1) Then
			startgame = False
			Exit
		End If
		
		If MouseHit(1) And MouseY() > 440 Then
			ExecFile("http://www.dpw-shane.pwp.blueyonder.co.uk")
		End If
		
		Flip
	
	Forever

End Function

Function PlayGame()

	frameTimer = CreateTimer(60)
	
	readytofire = True

	gy = 5
	
	Repeat

		WaitTimer(frameTimer)
		
		DrawBlock GameBackground,0,0
	
		DrawImage gun_top, gx, gy
		DrawImage gun_bottom, gx, ScrHeight - gy - ImageHeight(gun_bottom)
		
		Text 540,0,"score: " + score
		
		Color 240,240,0
		Text 500,FontHeight(),"high score: " + bestscore
		Color 255,255,255
		
		If ChannelPlaying(chnUfo) = 0 And ufoshown = True And (Not gameover) Then
			chnUfo = PlaySound(ufo_sound)
		End If
	
		If showupmissile And (Not gameover) Then
			DrawImage missile_up, mx, muy
			If muy > ScrHeight/2 Then
				muy = muy - 2
			Else 
				showupmissile = False
			End If
		End If
		
		If showdownmissile And (Not gameover) Then
			DrawImage missile_down, mx, mdy
			If mdy < ScrHeight/2 Then
				mdy = mdy + 2
			Else
				showdownmissile = False
			End If
		End If

		If gunsmoving And (Not gameover) Then
			If gx < ScrWidth Then
				gx = gx + 4
			Else
				gx = 0
				gunsmoving = False
			End If
		End If
		
		;If (Not gunsmoving) And (Not gameover) And (Not ufoshown) Then
		If (Not gameover) And (Not ufoshown) Then
			If Rand(1,6) = 1 Then
				ufoshown = True
				ux = ScrWidth
				uy = Rand(6,ScrHeight/10-7)*10
				uspeed = Rand(1,2) + Rand(0,2)
				chnUfo = PlaySound(ufo_sound)
			End If
		End If
		
		If ufoshown Then
			DrawImage ufo,ux,uy
			ux = ux - uspeed
		End If
		
		;check for collisions
		If ufoshown Then
			If uy < ScrHeight/2 Then
				If ImagesOverlap(missile_down,mx,mdy,ufo,ux,uy) Then
					;missile down has blown up the ufo
					ufoshown = False
					showdownmissile = False
					StopChannel chnUfo
					chnExplo = PlaySound(explosion_sound)
					score = score + 5*(uspeed)
				End If
			Else
				If ImagesOverlap(missile_up,mx,muy,ufo,ux,uy) Then
					;missile down has blown up the ufo
					ufoshown = False
					showupmissile = False
					StopChannel chnUfo
					chnExplo = PlaySound(explosion_sound)
					score = score + 5*(uspeed)
				End If
			End If
			If ux < 80 Then
				;check if this has hit the dam
				If DamArray(4,uy/10) = 1 Then 
					DamArray(4,uy/10) = 0
					ufoshown = False
					StopChannel chnUfo
					chnExplo = PlaySound(explosion_sound)
				End If
			End If
			If ux < 70 Then
				;check if this has hit the dam
				If DamArray(3,uy/10) = 1 Then 
					DamArray(3,uy/10) = 0
					ufoshown = False
					StopChannel chnUfo
					chnExplo = PlaySound(explosion_sound)
				End If
			End If
			If ux < 60 Then
				;check if this has hit the dam
				If DamArray(2,uy/10) = 1 Then 
					DamArray(2,uy/10) = 0
					ufoshown = False
					StopChannel chnUfo
					chnExplo = PlaySound(explosion_sound)
				End If
			End If
			If ux < 50 Then
				DamArray(1,uy/10) = 0
				ufoshown = False
				gameover = True
				gunsmoving = False
				missileupshown = False
				missiledownshown = False
				StopChannel chnUfo
				chnExplo = PlaySound(explosion_sound)
			End If
		End If
	
		If KeyHit(57) Then    ;space bar
			If gunsmoving And gx > 80 Then
				;player wants to fire missile
				If (Not showupmissile) And (Not showdownmissile) Then
					;fire missile
					showupmissile = True
					showdownmissile = True
					mx = gx + ImageWidth(gun_top)/2 - ImageWidth(missile_up)/2
					mdy = gy + ImageHeight(gun_top)
					muy = ScrHeight - gy - ImageHeight(gun_bottom)
					chnMiss = PlaySound(missile_sound)
				End If
			Else If (Not gameover)
				;player wants to start moving
				gunsmoving = True
			Else If gameover Then
				Exit
			End If
		End If
		
		For i = 1 To 4
			For j = 6 To ScrHeight/10 - 7
				If DamArray(i,j) > 0 Then
					DrawImage dam,(i+5)*10,j*10
				End If
			Next
		Next
		
		If gameover Then
			Color 255,255,255
			Text 320,FontHeight()*5,"Game over - the dam has been breached",True
			If score >= bestscore Then
				Text 320,FontHeight()*7,"But you have achieved a new high score",True
				If Not saved Then
					bestscore = score
					;save score
					UserDataFile = WriteFile("DamBreach.dat")
					WriteShort(UserDataFile, score)
    				CloseFile(UserDataFile)
					saved = True
				End If
			End If
		End If
		
		Flip
	
	Forever
	
	FreeTimer(frameTimer)
	
End Function

Function ExitGame()

	FreeImage ufo
	FreeImage gun_top
	FreeImage gun_bottom
	FreeImage missile_up
	FreeImage missile_down
	FreeImage dam
	FreeImage MenuBackground
	FreeImage GameBackground
	
	FreeSound ufo_sound
	FreeSound missile_sound
	FreeSound explosion_sound

End Function

End